/* Basic types, functions and macros */

typedef enum {
	false	= 0,
	true	= 1
} bool;

/* Utility functions and macros */

/* Print a message to stderr and exit.  Args as for printf. */
void die(char *msg,...);

/* Allocate specified number of bytes. */
void *alloc(size_t length); 

/* Allocate copy of specified string. */
char *stralloc(char *s);

#define STR_EQ(a,b) (strcmp((a),(b)) == 0)
