/* Runtime facilities */

/* Exceptions */
typedef enum 
  {OUT_OF_MEMORY_EXN=0,
   STACK_OVERFLOW_EXN,
   NULL_PTR_EXN,
   INDEX_BOUNDS_EXN,
   ARRAY_SIZE_EXN} exn;

/* Raise an exception */
void exception(exn reason);

void print_int(int i);
void print_string(char *s);

void initialize_heap(size_t heap_size,uintptr_t *first_root,uintptr_t **last_root_ptr,char **root_types);

uintptr_t *alloc_array(int32_t size);
int32_t array_length(uintptr_t *a);
void array_store(uintptr_t *a,int32_t index,int32_t v);
int32_t array_load(uintptr_t *a,int32_t index);
uintptr_t *alloc_object(Class *class);
uintptr_t get_field(uintptr_t *object,size_t offset);
void put_field(uintptr_t *object,size_t offset,uintptr_t value);

